#include <stdio.h>
#include "tcplib.h"

void handle_session(socket_base *sock)
{
	int len;
	char buf[200];

	while((len = sock->recv(buf, 200)) > 0)
	{
		printf("%.*s", len, buf);
	}
}

int example_client()
{
	tcp_socket sock;
	char buf[200];

	if(!sock.create())
		return 0;

	// connect
	sock.connect("www.google.com", 80);

	// send a string
	strcpy(buf, "GET / HTTP/1.0\r\n\r\n");
	sock.send(buf, strlen(buf));

	// read response
	handle_session(&sock);

	sock.shutdown(SD_BOTH);
	sock.close();
	return 0;
}


int example_server()
{
	tcp_socket server;
	socket_base *sock;

	if(!server.create())
		return 0;

	// listen on TCP port 5555
	if(!server.listen(5555))
		return 0;

	// wait for someone to connect
	if(!server.accept(&sock))
		return 0;

	// read what the send us
	handle_session(sock);

	delete sock;

	server.shutdown(SD_BOTH);
	server.close();
	return 0;
}


int main()
{
	if(!socket_base::startup())
		return 0;

	example_client();

	example_server();

	socket_base::cleanup();
	return 0;
}