#include "socklib.h"

#pragma comment(lib, "ws2_32.lib")

DWORD socket_base::lookup_ip(const char *hostname)
{
	struct hostent *pent;
	DWORD  ip;

	ip = inet_addr(hostname);

	if(ip == INADDR_NONE)
	{
		pent = gethostbyname(hostname);

		if(pent == NULL)
			ip = 0;
		else
			ip = *(DWORD *)pent->h_addr_list[0];
	}
	
	return ntohl(ip);
}

bool socket_base::startup()
{
	WSADATA wsa;

	if(WSAStartup(MAKEWORD( 1, 1 ), &wsa) == 0)
		return true;
	else
		return false;
}

bool socket_base::cleanup()
{
	WSACleanup();
	return true;
}

