#ifndef SOCKBASE_INCLUDED
#define SOCKBASE_INCLUDED

#include <winsock2.h>
#include <windows.h>

#pragma comment(lib, "ws2_32.lib")

typedef bool (*acceptproc)(DWORD ip, DWORD param);

class socket_base
{
public:
	virtual ~socket_base() {}
	
	virtual bool create() = 0;
	virtual bool close()  = 0;
	virtual bool shutdown(int how)  = 0;

	virtual bool connect	(DWORD ip, int port)								= 0;
	virtual bool connect	(const char *hostname, int port)					= 0;
	virtual bool listen		(int port, DWORD ip = INADDR_ANY)					= 0;
	virtual bool accept		(socket_base **newsock, DWORD *clientip = 0)		= 0;
	
	virtual bool getpeer	(DWORD *ip, int *port)								= 0;

	virtual int  recv		(void *buf, int num_bytes, long timeout = INFINITE)	= 0;
	virtual int  recv_exact	(void *buf, int num_bytes, long timeout = INFINITE)	= 0;
	virtual int  send		(void *buf, int num_bytes)							= 0;

	virtual void allow		(DWORD ip = INADDR_ANY, acceptproc aproc = 0, DWORD param = 0)= 0;
	virtual bool connected  ()												    = 0;

	static bool startup();
	static bool cleanup();
	static DWORD lookup_ip(const char *hostname);
};

#endif