#ifndef TCP_INCLUDED
#define TCP_INCLUDED

#include "socklib.h"

class tcp_socket : public socket_base
{
public:
	tcp_socket(SOCKET sock) : m_sock(sock) {}
	tcp_socket();
	~tcp_socket();

	bool create();
	bool create(SOCKET sock);

	bool shutdown(int how);

	bool connect(DWORD ip,             int port);
	bool connect(const char *hostname, int port);

	bool close();
	
	bool listen(int port, DWORD ip = INADDR_ANY);
	bool accept(socket_base **newsock, DWORD *clientip = 0);

	int recv      (void *buf, int num_bytes, long timeout = INFINITE);
	int recv_exact(void *buf, int num_bytes, long timeout = INFINITE);
	int send	  (void *buf, int num_bytes);//, long timeout = INFINITE);

	bool connected();

	bool getpeer(DWORD *ip, int *port);
	bool getself(DWORD *ip, int *port);

	void allow(DWORD ip = INADDR_ANY, acceptproc ap = 0, DWORD param = 0);

private:

	int  select(long time);

	SOCKET m_sock;
	DWORD  m_allow;
	bool   m_connected;
	
	acceptproc m_accept_callback;
	DWORD  m_accept_param;

	tcp_socket(tcp_socket&);
	tcp_socket& operator = (tcp_socket &);
};

#endif