#ifndef UDP_INCLUDED
#define UDP_INCLUDED

#include "socklib.h"

class udp_socket : public socket_base
{
public:
	udp_socket(SOCKET sock) : m_sock(sock) {}
	udp_socket();
	~udp_socket();

	bool  create();
	bool  close();
	bool  shutdown(int how);

	bool connect(DWORD ip, int port);
	bool connect(const char *hostname, int port);
	bool listen(int port, DWORD ip = INADDR_ANY);
	bool accept(socket_base **newsock, DWORD *clientip = 0);

	void allow(DWORD ip = INADDR_ANY, acceptproc ap = 0, DWORD param = 0);
	bool getpeer(DWORD *ip, int *port);

	int  recv       (void *buf, int num_bytes, long timeout = INFINITE);
	int  recv_exact (void *buf, int num_bytes, long timeout = INFINITE);
	int  recvfrom   (void *buf, int num_bytes, DWORD *ip, int *port, long timeout = INFINITE);

	int  send   (void *buf, int num_bytes);
	int  sendto (void *buf, int num_bytes, DWORD ip, int port);

	bool connected();

private:

	int select(long time);

	SOCKET m_sock;

	DWORD  m_allow;
	bool   m_boundtopeer;

	DWORD  m_lastip;
	DWORD  m_lastport;

	bool   m_connected;

	acceptproc m_accept_callback;
	DWORD  m_accept_param;
};

#endif